/*
Copyright (C) 2006 - 2009 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef BINARYINFO_20070718_H_
#define BINARYINFO_20070718_H_

#include "Types.h"
#include "API.h"
#include "MemRegion.h"

class EDB_EXPORT BinaryInfo {
public:
	BinaryInfo(const MemRegion &region);
	virtual ~BinaryInfo() {}
	
public:
	virtual bool validateHeader() = 0;
	virtual edb::address_t entryPoint() = 0;
	virtual bool nativeBinary() = 0;
	
public:
	// optional, and platform specific:
	// if there is a structure in the target process which has debug data
	// this should return a pointer to it
	virtual edb::address_t debugPointer() { return edb::nullptr; }

protected:
	MemRegion m_Region;
	
public:
	typedef BinaryInfo *(*createFuncPtr)(const MemRegion &);
};

#endif

