/*
Copyright (C) 2006 - 2009 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef DEBUGEVENTBASE_20090527_H_
#define DEBUGEVENTBASE_20090527_H_

#include <QString>

class DebugEventBase {
public:
	enum REASON {
		EVENT_EXITED,	// exited normally
		EVENT_SIGNALED,	// application recieved a signal
		EVENT_STOPPED,	// we recieved an event
		EVENT_UNKNOWN
	};
	
	enum TRAP_REASON {
		TRAP_STEPPING,
		TRAP_BREAKPOINT
	};
	
	struct Message {
		Message(const QString &c, const QString &m) : caption(c), message(m) {
		}
		
		Message() {
		}
		
		QString caption;
		QString message;
	};
	
	virtual ~DebugEventBase() {}
	
public:
	virtual REASON reason() const = 0;
	virtual TRAP_REASON trapReason() const = 0;
	virtual edb::tid_t thread() const = 0;
	virtual edb::pid_t process() const = 0;
	
};

#endif
