/*
Copyright (C) 2006 - 2009 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef DIALOGHEAP_20061101_H_
#define DIALOGHEAP_20061101_H_

#include "ui_dialogheap.h"
#include "Types.h"
#include "ResultViewModel.h"

class QSortFilterProxyModel;

class DialogHeap : public QDialog {
	Q_OBJECT
	
public:
	DialogHeap(QWidget *parent = 0);

public Q_SLOTS:
	void on_btnFind_clicked();
	void on_btnGraph_clicked();
	void on_tableView_doubleClicked(const QModelIndex & index);
	
private:
	virtual void showEvent(QShowEvent *event);
	
	void getLibraryNames(QString &libcName, QString &ldName) const;
	void collectBlocks(edb::address_t start_address, edb::address_t end_address);
	void detectPointers();
	void doFind();
	void processPotentialPointer(const QMap<edb::address_t, edb::address_t> &targets, Result &result);
	
	edb::address_t findHeapStartHeuristic(edb::address_t end_address, size_t offset) const;
	
private:
	static edb::address_t blockStart(const Result &result);
	static edb::address_t blockStart(const Result *result);
	static edb::address_t blockStart(edb::address_t pointer);
	
private:
	 Ui::DialogHeap		ui;
	 ResultViewModel	*m_Model;
};

#endif
